/*
 *  July 5, 2000    Architecture defintions
 *
 *                   -- George France <france@crl.dec.com>
 */

/* There can be 255 platforms       ( 8 bit)
   Each platform can have 255 cpus  ( 8 bit)
   Each cpu can have 65355 machines (16 bit) */

#define ARM_PLATFORM   1
   #define ARM_SA110_CPU   1
   #define ARM_SA1100_CPU  2
   #define ARM_SA1110_CPU  3
   #define ARM_SA1111_CPU  4

#define MIPS_PLATFORM  2

#define SKIFF_MACH      1
#define ITSY_MACH       2 
#define BITSY_MACH      3
#define ASSABET_MACH	4
#define NEPONSET_MACH	5
#define JORNADA720_MACH	6

#define ASSABET_ARCH ((ARM_PLATFORM << 24) | (ARM_SA1110_CPU << 16) | ASSABET_MACH)
#define BITSY_ARCH ((ARM_PLATFORM << 24) | (ARM_SA1110_CPU << 16) | BITSY_MACH)
#define JORNADA720_ARCH ((ARM_PLATFORM << 24) | (ARM_SA1110_CPU << 16) | JORNADA720_MACH)
#define NEPONSET_ARCH ((ARM_PLATFORM << 24) | (ARM_SA1110_CPU << 16) | NEPONSET_MACH)
#define SKIFF_ARCH ((ARM_PLATFORM << 24) | (ARM_SA110_CPU  << 16) | SKIFF_MACH )

#ifdef CONFIG_ASSABET
#define ARCHITECTURE_MAGIC ASSABET_ARCH
#endif
#ifdef CONFIG_BITSY
#define ARCHITECTURE_MAGIC BITSY_ARCH
#endif
#ifdef CONFIG_JORNADA720
#define ARCHITECTURE_MAGIC JORNADA720_ARCH
#endif
#ifdef CONFIG_NEPONSET
#define ARCHITECTURE_MAGIC NEPONSET_ARCH
#endif
#ifdef CONFIG_SKIFF
#define ARCHITECTURE_MAGIC SKIFF_ARCH
#endif

 


