#ifndef BOOT_FLAGS_H_INCLUDED
#define BOOT_FLAGS_H_INCLUDED

/*
 * these bits control the boot flow.
 * They are stored initially in the SA1100_PWER register.
 * Then, once RAM is running, they are stored in RAM
 * The current location is pointed to by Boot_flags_ptr.
 */

#define	BF_SQUELCH_SERIAL	(1<<0)
#define	BF_SLEEP_RESET		(1<<1)

#ifdef CONFIG_BITSY

#ifndef __ASSEMBLY__
extern unsigned long*	Boot_flags_ptr;
/*  extern void*	Boot_flags_ptr; */
#endif

#define	squelch_serial()	((*Boot_flags_ptr) & BF_SQUELCH_SERIAL)
#define	clr_squelch_serial()    (*Boot_flags_ptr &= ~BF_SQUELCH_SERIAL)
#define	set_squelch_serial()    (*Boot_flags_ptr |=  BF_SQUELCH_SERIAL)

#define	tst_sleep_reset()	((*Boot_flags_ptr) & BF_SLEEP_RESET)
#define	clr_sleep_reset()	(*Boot_flags_ptr &= ~BF_SLEEP_RESET)
#define	set_sleep_reset()	(*Boot_flags_ptr |=  BF_SLEEP_RESET)

#else

#define	squelch_serial()	(0)
#define	clr_squelch_serial()
#define	set_squelch_serial()

#define	tst_sleep_reset()	(0)
#define	clr_sleep_reset()
#define	set_sleep_reset()

#endif

#define BL_SIG		"BTSY"
#define BL_SIG_OFFSET	0x34

#endif
